#-- Lattice Semiconductor Corporation Ltd.
#-- Synplify OEM project file .\ramen_timer.tcl
#-- Written on Thu Jun 04 01:46:12 2009

project -close
set filename ramen_timer_syn.prj
if ([file exists $filename]) {
project -load "$filename"
project_file -remove *
set_option -include_path ""
} else {
project -new "$filename" 
} 

#device options
set_option -technology LATTICE-XP2
set_option -part LFXP2_5E
set_option -speed_grade -6

#-- add_file options
add_file -vhdl -lib work "C:/ispTOOLS7_2_STRT/ispcpld/../cae_library/synthesis/vhdl/xp2.vhd"
add_file -vhdl -lib work "counter10.vhd"
add_file -vhdl -lib work "ramen_timer.vhd"
project -result_file ".\/ramen_timer.edi"
project -save ramen_timer_syn.prj

########## Tcl recorder starts at 06/04/09 01:48:30 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Generate Data File (JEDEC)
if [runCmd "\"$fpga_bin/edif2ngd\" -l LatticeXP2 -d LFXP2-5E \"ramen_timer.edi\" \"ramen_timer.ngo\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edfupdate\" -t \"ramen_timer.tcy\" -w \"ramen_timer.ngo\" -m \"ramen_timer.ngo\" \"ramen_timer.ngx\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/ngdbuild\" -a LatticeXP2 -d LFXP2-5E -p \"$fpga_dir/mg5a00/data\" \"ramen_timer.ngo\" \"ramen_timer.ngd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/map\" -a LatticeXP2 -p LFXP2-5E -t TQFP144 -s 6 \"ramen_timer.ngd\" -o \"ramen_timer_map.ncd\" -mp \"ramen_timer.mrp\" \"ramen_timer.lpf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.mt
-to ramen_timer.tw1
-o ramen_timer.tcm
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.mrp
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -m -f \"ramen_timer.cmm\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer_map.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.p2t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p2t: $rspFile"
} else {
	puts $rspFile "-w
-i 6
-l 5
-n 1
-t 1
-s 1
-c 0
-e 0
-exp parCDP=Auto
-exp parCDR=1
-exp parPlcInLimit=0
-exp parPlcInNeighborSize=1
-exp parPathBased=OFF
-exp parHold=OFF
"
	close $rspFile
}
if [catch {open ramen_timer.p3t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p3t: $rspFile"
} else {
	puts $rspFile "-rem
-log ramen_timer.log
-o ramen_timer_mp.par
-pr ramen_timer.prf
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/multipar\" -p ramen_timer.p2t -f \"ramen_timer.p3t\" \"ramen_timer_map.ncd\" \"ramen_timer.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.pt
-to ramen_timer.twr
-o ramen_timer.tcp
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.par
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -p -f \"ramen_timer.cmp\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer.ncd\" -l 60"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.t2b w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.t2b: $rspFile"
} else {
	puts $rspFile "-g DisableUES:FALSE
-g RamCfg:Reset
"
	close $rspFile
}
if [runCmd "\"$fpga_bin/bitgen\" -f \"ramen_timer.t2b\" -w \"ramen_timer.ncd\" -jedec -e -s \"ramen_timer.sec\" -k \"ramen_timer.bek\" \"ramen_timer.prf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/04/09 01:48:30 ###########


########## Tcl recorder starts at 06/04/09 01:57:09 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Synplify Synthesize VHDL File
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open ramen_timer.cmd w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: ramen_timer
WORKING_PATH: \"$proj_dir\"
MODULE: work.ramen_timer
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: ramen_timer
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e ramen_timer -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/04/09 01:57:09 ###########


########## Tcl recorder starts at 06/04/09 01:57:35 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Generate Data File (JEDEC)
if [runCmd "\"$fpga_bin/edif2ngd\" -l LatticeXP2 -d LFXP2-5E \"ramen_timer.edi\" \"ramen_timer.ngo\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edfupdate\" -t \"ramen_timer.tcy\" -w \"ramen_timer.ngo\" -m \"ramen_timer.ngo\" \"ramen_timer.ngx\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/ngdbuild\" -a LatticeXP2 -d LFXP2-5E -p \"$fpga_dir/mg5a00/data\" \"ramen_timer.ngo\" \"ramen_timer.ngd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/map\" -a LatticeXP2 -p LFXP2-5E -t TQFP144 -s 6 \"ramen_timer.ngd\" -o \"ramen_timer_map.ncd\" -mp \"ramen_timer.mrp\" \"ramen_timer.lpf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.mt
-to ramen_timer.tw1
-o ramen_timer.tcm
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.mrp
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -m -f \"ramen_timer.cmm\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer_map.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.p2t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p2t: $rspFile"
} else {
	puts $rspFile "-w
-i 6
-l 5
-n 1
-t 1
-s 1
-c 0
-e 0
-exp parCDP=Auto
-exp parCDR=1
-exp parPlcInLimit=0
-exp parPlcInNeighborSize=1
-exp parPathBased=OFF
-exp parHold=OFF
"
	close $rspFile
}
if [catch {open ramen_timer.p3t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p3t: $rspFile"
} else {
	puts $rspFile "-rem
-log ramen_timer.log
-o ramen_timer_mp.par
-pr ramen_timer.prf
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/multipar\" -p ramen_timer.p2t -f \"ramen_timer.p3t\" \"ramen_timer_map.ncd\" \"ramen_timer.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.pt
-to ramen_timer.twr
-o ramen_timer.tcp
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.par
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -p -f \"ramen_timer.cmp\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer.ncd\" -l 60"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.t2b w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.t2b: $rspFile"
} else {
	puts $rspFile "-g DisableUES:FALSE
-g RamCfg:Reset
"
	close $rspFile
}
if [runCmd "\"$fpga_bin/bitgen\" -f \"ramen_timer.t2b\" -w \"ramen_timer.ncd\" -jedec -e -s \"ramen_timer.sec\" -k \"ramen_timer.bek\" \"ramen_timer.prf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/04/09 01:57:35 ###########


########## Tcl recorder starts at 06/04/09 02:06:20 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Design Planner (Pre-Map)
# - none -
# Application to view the Process: 
# Design Planner (Pre-Map)
if [catch {open lattice.rsb w} rspFile] {
	puts stderr "Cannot create response file lattice.rsb: $rspFile"
} else {
	puts $rspFile "-inp \"ramen_timer.ngd\" -dir \"$proj_dir\" -prj \"ramen_timer\" -gui -touch ngd -a LatticeXP2 -p LFXP2-5E -t TQFP144 -lpf \"ramen_timer.lpf\" -msg \"Pre-Map Design Floorplan\"
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/flmainappw\" @lattice.rsb"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/04/09 02:06:20 ###########


########## Tcl recorder starts at 06/04/09 02:09:36 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Map Design
if [runCmd "\"$fpga_bin/map\" -a LatticeXP2 -p LFXP2-5E -t TQFP144 -s 6 \"ramen_timer.ngd\" -o \"ramen_timer_map.ncd\" -mp \"ramen_timer.mrp\" \"ramen_timer.lpf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/04/09 02:09:36 ###########


########## Tcl recorder starts at 06/04/09 02:09:45 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Place & Route Design
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.mt
-to ramen_timer.tw1
-o ramen_timer.tcm
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.mrp
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -m -f \"ramen_timer.cmm\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer_map.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.p2t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p2t: $rspFile"
} else {
	puts $rspFile "-w
-i 6
-l 5
-n 1
-t 1
-s 1
-c 0
-e 0
-exp parCDP=Auto
-exp parCDR=1
-exp parPlcInLimit=0
-exp parPlcInNeighborSize=1
-exp parPathBased=OFF
-exp parHold=OFF
"
	close $rspFile
}
if [catch {open ramen_timer.p3t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p3t: $rspFile"
} else {
	puts $rspFile "-rem
-log ramen_timer.log
-o ramen_timer_mp.par
-pr ramen_timer.prf
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/multipar\" -p ramen_timer.p2t -f \"ramen_timer.p3t\" \"ramen_timer_map.ncd\" \"ramen_timer.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/04/09 02:09:45 ###########


########## Tcl recorder starts at 06/04/09 02:11:12 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Generate Data File (JEDEC)
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.pt
-to ramen_timer.twr
-o ramen_timer.tcp
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.par
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -p -f \"ramen_timer.cmp\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer.ncd\" -l 60"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.t2b w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.t2b: $rspFile"
} else {
	puts $rspFile "-g DisableUES:FALSE
-g RamCfg:Reset
"
	close $rspFile
}
if [runCmd "\"$fpga_bin/bitgen\" -f \"ramen_timer.t2b\" -w \"ramen_timer.ncd\" -jedec -e -s \"ramen_timer.sec\" -k \"ramen_timer.bek\" \"ramen_timer.prf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/04/09 02:11:12 ###########


########## Tcl recorder starts at 06/05/09 01:07:21 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Generate Data File (JEDEC)
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open ramen_timer.cmd w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: ramen_timer
WORKING_PATH: \"$proj_dir\"
MODULE: work.ramen_timer
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: ramen_timer
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e ramen_timer -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edif2ngd\" -l LatticeXP2 -d LFXP2-5E \"ramen_timer.edi\" \"ramen_timer.ngo\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edfupdate\" -t \"ramen_timer.tcy\" -w \"ramen_timer.ngo\" -m \"ramen_timer.ngo\" \"ramen_timer.ngx\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/ngdbuild\" -a LatticeXP2 -d LFXP2-5E -p \"$fpga_dir/mg5a00/data\" \"ramen_timer.ngo\" \"ramen_timer.ngd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/map\" -a LatticeXP2 -p LFXP2-5E -t TQFP144 -s 6 \"ramen_timer.ngd\" -o \"ramen_timer_map.ncd\" -mp \"ramen_timer.mrp\" \"ramen_timer.lpf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.mt
-to ramen_timer.tw1
-o ramen_timer.tcm
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.mrp
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -m -f \"ramen_timer.cmm\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer_map.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.p2t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p2t: $rspFile"
} else {
	puts $rspFile "-w
-i 6
-l 5
-n 1
-t 1
-s 1
-c 0
-e 0
-exp parCDP=Auto
-exp parCDR=1
-exp parPlcInLimit=0
-exp parPlcInNeighborSize=1
-exp parPathBased=OFF
-exp parHold=OFF
"
	close $rspFile
}
if [catch {open ramen_timer.p3t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p3t: $rspFile"
} else {
	puts $rspFile "-rem
-log ramen_timer.log
-o ramen_timer_mp.par
-pr ramen_timer.prf
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/multipar\" -p ramen_timer.p2t -f \"ramen_timer.p3t\" \"ramen_timer_map.ncd\" \"ramen_timer.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.pt
-to ramen_timer.twr
-o ramen_timer.tcp
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.par
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -p -f \"ramen_timer.cmp\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer.ncd\" -l 60"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.t2b w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.t2b: $rspFile"
} else {
	puts $rspFile "-g DisableUES:FALSE
-g RamCfg:Reset
"
	close $rspFile
}
if [runCmd "\"$fpga_bin/bitgen\" -f \"ramen_timer.t2b\" -w \"ramen_timer.ncd\" -jedec -e -s \"ramen_timer.sec\" -k \"ramen_timer.bek\" \"ramen_timer.prf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/05/09 01:07:21 ###########


########## Tcl recorder starts at 06/05/09 01:14:05 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Generate Data File (JEDEC)
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open ramen_timer.cmd w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: ramen_timer
WORKING_PATH: \"$proj_dir\"
MODULE: work.ramen_timer
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: ramen_timer
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e ramen_timer -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edif2ngd\" -l LatticeXP2 -d LFXP2-5E \"ramen_timer.edi\" \"ramen_timer.ngo\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edfupdate\" -t \"ramen_timer.tcy\" -w \"ramen_timer.ngo\" -m \"ramen_timer.ngo\" \"ramen_timer.ngx\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/ngdbuild\" -a LatticeXP2 -d LFXP2-5E -p \"$fpga_dir/mg5a00/data\" \"ramen_timer.ngo\" \"ramen_timer.ngd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/map\" -a LatticeXP2 -p LFXP2-5E -t TQFP144 -s 6 \"ramen_timer.ngd\" -o \"ramen_timer_map.ncd\" -mp \"ramen_timer.mrp\" \"ramen_timer.lpf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.mt
-to ramen_timer.tw1
-o ramen_timer.tcm
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.mrp
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -m -f \"ramen_timer.cmm\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer_map.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.p2t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p2t: $rspFile"
} else {
	puts $rspFile "-w
-i 6
-l 5
-n 1
-t 1
-s 1
-c 0
-e 0
-exp parCDP=Auto
-exp parCDR=1
-exp parPlcInLimit=0
-exp parPlcInNeighborSize=1
-exp parPathBased=OFF
-exp parHold=OFF
"
	close $rspFile
}
if [catch {open ramen_timer.p3t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p3t: $rspFile"
} else {
	puts $rspFile "-rem
-log ramen_timer.log
-o ramen_timer_mp.par
-pr ramen_timer.prf
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/multipar\" -p ramen_timer.p2t -f \"ramen_timer.p3t\" \"ramen_timer_map.ncd\" \"ramen_timer.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.pt
-to ramen_timer.twr
-o ramen_timer.tcp
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.par
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -p -f \"ramen_timer.cmp\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer.ncd\" -l 60"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.t2b w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.t2b: $rspFile"
} else {
	puts $rspFile "-g DisableUES:FALSE
-g RamCfg:Reset
"
	close $rspFile
}
if [runCmd "\"$fpga_bin/bitgen\" -f \"ramen_timer.t2b\" -w \"ramen_timer.ncd\" -jedec -e -s \"ramen_timer.sec\" -k \"ramen_timer.bek\" \"ramen_timer.prf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/05/09 01:14:05 ###########


########## Tcl recorder starts at 06/05/09 01:37:58 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Generate Data File (JEDEC)
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open ramen_timer.cmd w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: ramen_timer
WORKING_PATH: \"$proj_dir\"
MODULE: work.ramen_timer
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: ramen_timer
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e ramen_timer -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edif2ngd\" -l LatticeXP2 -d LFXP2-5E \"ramen_timer.edi\" \"ramen_timer.ngo\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edfupdate\" -t \"ramen_timer.tcy\" -w \"ramen_timer.ngo\" -m \"ramen_timer.ngo\" \"ramen_timer.ngx\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/ngdbuild\" -a LatticeXP2 -d LFXP2-5E -p \"$fpga_dir/mg5a00/data\" \"ramen_timer.ngo\" \"ramen_timer.ngd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/map\" -a LatticeXP2 -p LFXP2-5E -t TQFP144 -s 6 \"ramen_timer.ngd\" -o \"ramen_timer_map.ncd\" -mp \"ramen_timer.mrp\" \"ramen_timer.lpf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.mt
-to ramen_timer.tw1
-o ramen_timer.tcm
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.mrp
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -m -f \"ramen_timer.cmm\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer_map.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.p2t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p2t: $rspFile"
} else {
	puts $rspFile "-w
-i 6
-l 5
-n 1
-t 1
-s 1
-c 0
-e 0
-exp parCDP=Auto
-exp parCDR=1
-exp parPlcInLimit=0
-exp parPlcInNeighborSize=1
-exp parPathBased=OFF
-exp parHold=OFF
"
	close $rspFile
}
if [catch {open ramen_timer.p3t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p3t: $rspFile"
} else {
	puts $rspFile "-rem
-log ramen_timer.log
-o ramen_timer_mp.par
-pr ramen_timer.prf
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/multipar\" -p ramen_timer.p2t -f \"ramen_timer.p3t\" \"ramen_timer_map.ncd\" \"ramen_timer.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.pt
-to ramen_timer.twr
-o ramen_timer.tcp
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.par
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -p -f \"ramen_timer.cmp\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer.ncd\" -l 60"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.t2b w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.t2b: $rspFile"
} else {
	puts $rspFile "-g DisableUES:FALSE
-g RamCfg:Reset
"
	close $rspFile
}
if [runCmd "\"$fpga_bin/bitgen\" -f \"ramen_timer.t2b\" -w \"ramen_timer.ncd\" -jedec -e -s \"ramen_timer.sec\" -k \"ramen_timer.bek\" \"ramen_timer.prf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/05/09 01:37:58 ###########


########## Tcl recorder starts at 06/05/09 22:14:51 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Build Database
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open ramen_timer.cmd w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: ramen_timer
WORKING_PATH: \"$proj_dir\"
MODULE: work.ramen_timer
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: ramen_timer
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e ramen_timer -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edif2ngd\" -l LatticeXP2 -d LFXP2-5E \"ramen_timer.edi\" \"ramen_timer.ngo\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edfupdate\" -t \"ramen_timer.tcy\" -w \"ramen_timer.ngo\" -m \"ramen_timer.ngo\" \"ramen_timer.ngx\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/ngdbuild\" -a LatticeXP2 -d LFXP2-5E -p \"$fpga_dir/mg5a00/data\" \"ramen_timer.ngo\" \"ramen_timer.ngd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/05/09 22:14:51 ###########


########## Tcl recorder starts at 06/05/09 22:35:28 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Synplify Synthesize VHDL File
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open SyncReset.cmd w} rspFile] {
	puts stderr "Cannot create response file SyncReset.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: SyncReset
WORKING_PATH: \"$proj_dir\"
MODULE: work.SyncReset
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: SyncReset
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e SyncReset -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/05/09 22:35:28 ###########


########## Tcl recorder starts at 06/05/09 22:37:17 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Synplify Synthesize VHDL File
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open SyncReset.cmd w} rspFile] {
	puts stderr "Cannot create response file SyncReset.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: SyncReset
WORKING_PATH: \"$proj_dir\"
MODULE: work.SyncReset
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: SyncReset
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e SyncReset -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/05/09 22:37:17 ###########


########## Tcl recorder starts at 06/05/09 22:37:36 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# VHDL Test Bench Template
if [catch {open SyncReset.rsp w} rspFile] {
	puts stderr "Cannot create response file SyncReset.rsp: $rspFile"
} else {
	puts $rspFile "sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/hdl2jhd\" -tfi -proj \"ramen_timer\" -mod SyncReset  -out \"SyncReset\" -tpl \"$install_dir/ispcpld/generic/vhdl/tstbch_f.tft\" -ext vht -pf \"$install_dir/ispcpld/../cae_library/synthesis/verilog/XP2.v\" -setting ramen_timer.sty -lst SyncReset.rsp"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete SyncReset.rsp

########## Tcl recorder end at 06/05/09 22:37:36 ###########


########## Tcl recorder starts at 06/05/09 22:38:42 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Synthesized EDIF File
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open SyncReset.cmd w} rspFile] {
	puts stderr "Cannot create response file SyncReset.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: SyncReset
WORKING_PATH: \"$proj_dir\"
MODULE: work.SyncReset
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: SyncReset
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e SyncReset -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/05/09 22:38:42 ###########


########## Tcl recorder starts at 06/05/09 22:40:45 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Synplify Synthesize VHDL File
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open SyncReset.cmd w} rspFile] {
	puts stderr "Cannot create response file SyncReset.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: SyncReset
WORKING_PATH: \"$proj_dir\"
MODULE: work.SyncReset
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: SyncReset
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e SyncReset -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/05/09 22:40:45 ###########


########## Tcl recorder starts at 06/05/09 22:41:12 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Generate Data File (JEDEC)
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open ramen_timer.cmd w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: ramen_timer
WORKING_PATH: \"$proj_dir\"
MODULE: work.ramen_timer
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: ramen_timer
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e ramen_timer -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edif2ngd\" -l LatticeXP2 -d LFXP2-5E \"ramen_timer.edi\" \"ramen_timer.ngo\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edfupdate\" -t \"ramen_timer.tcy\" -w \"ramen_timer.ngo\" -m \"ramen_timer.ngo\" \"ramen_timer.ngx\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/ngdbuild\" -a LatticeXP2 -d LFXP2-5E -p \"$fpga_dir/mg5a00/data\" \"ramen_timer.ngo\" \"ramen_timer.ngd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/map\" -a LatticeXP2 -p LFXP2-5E -t TQFP144 -s 6 \"ramen_timer.ngd\" -o \"ramen_timer_map.ncd\" -mp \"ramen_timer.mrp\" \"ramen_timer.lpf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.mt
-to ramen_timer.tw1
-o ramen_timer.tcm
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.mrp
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -m -f \"ramen_timer.cmm\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer_map.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.p2t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p2t: $rspFile"
} else {
	puts $rspFile "-w
-i 6
-l 5
-n 1
-t 1
-s 1
-c 0
-e 0
-exp parCDP=Auto
-exp parCDR=1
-exp parPlcInLimit=0
-exp parPlcInNeighborSize=1
-exp parPathBased=OFF
-exp parHold=OFF
"
	close $rspFile
}
if [catch {open ramen_timer.p3t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p3t: $rspFile"
} else {
	puts $rspFile "-rem
-log ramen_timer.log
-o ramen_timer_mp.par
-pr ramen_timer.prf
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/multipar\" -p ramen_timer.p2t -f \"ramen_timer.p3t\" \"ramen_timer_map.ncd\" \"ramen_timer.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.pt
-to ramen_timer.twr
-o ramen_timer.tcp
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.par
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -p -f \"ramen_timer.cmp\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer.ncd\" -l 60"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.t2b w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.t2b: $rspFile"
} else {
	puts $rspFile "-g DisableUES:FALSE
-g RamCfg:Reset
"
	close $rspFile
}
if [runCmd "\"$fpga_bin/bitgen\" -f \"ramen_timer.t2b\" -w \"ramen_timer.ncd\" -jedec -e -s \"ramen_timer.sec\" -k \"ramen_timer.bek\" \"ramen_timer.prf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/05/09 22:41:12 ###########


########## Tcl recorder starts at 06/05/09 22:46:27 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Design Planner (Pre-Map)
# - none -
# Application to view the Process: 
# Design Planner (Pre-Map)
if [catch {open lattice.rsb w} rspFile] {
	puts stderr "Cannot create response file lattice.rsb: $rspFile"
} else {
	puts $rspFile "-inp \"ramen_timer.ngd\" -dir \"$proj_dir\" -prj \"ramen_timer\" -gui -touch ngd -a LatticeXP2 -p LFXP2-5E -t TQFP144 -lpf \"ramen_timer.lpf\" -msg \"Pre-Map Design Floorplan\"
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/flmainappw\" @lattice.rsb"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/05/09 22:46:27 ###########


########## Tcl recorder starts at 06/05/09 22:49:34 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Map Design
if [runCmd "\"$fpga_bin/map\" -a LatticeXP2 -p LFXP2-5E -t TQFP144 -s 6 \"ramen_timer.ngd\" -o \"ramen_timer_map.ncd\" -mp \"ramen_timer.mrp\" \"ramen_timer.lpf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/05/09 22:49:34 ###########


########## Tcl recorder starts at 06/05/09 22:49:51 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Place & Route Design
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.mt
-to ramen_timer.tw1
-o ramen_timer.tcm
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.mrp
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -m -f \"ramen_timer.cmm\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer_map.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.p2t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p2t: $rspFile"
} else {
	puts $rspFile "-w
-i 6
-l 5
-n 1
-t 1
-s 1
-c 0
-e 0
-exp parCDP=Auto
-exp parCDR=1
-exp parPlcInLimit=0
-exp parPlcInNeighborSize=1
-exp parPathBased=OFF
-exp parHold=OFF
"
	close $rspFile
}
if [catch {open ramen_timer.p3t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p3t: $rspFile"
} else {
	puts $rspFile "-rem
-log ramen_timer.log
-o ramen_timer_mp.par
-pr ramen_timer.prf
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/multipar\" -p ramen_timer.p2t -f \"ramen_timer.p3t\" \"ramen_timer_map.ncd\" \"ramen_timer.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/05/09 22:49:51 ###########


########## Tcl recorder starts at 06/05/09 22:51:24 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Generate Data File (JEDEC)
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.pt
-to ramen_timer.twr
-o ramen_timer.tcp
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.par
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -p -f \"ramen_timer.cmp\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer.ncd\" -l 60"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.t2b w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.t2b: $rspFile"
} else {
	puts $rspFile "-g DisableUES:FALSE
-g RamCfg:Reset
"
	close $rspFile
}
if [runCmd "\"$fpga_bin/bitgen\" -f \"ramen_timer.t2b\" -w \"ramen_timer.ncd\" -jedec -e -s \"ramen_timer.sec\" -k \"ramen_timer.bek\" \"ramen_timer.prf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/05/09 22:51:24 ###########


########## Tcl recorder starts at 06/05/09 23:03:49 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Generate Data File (JEDEC)
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open ramen_timer.cmd w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: ramen_timer
WORKING_PATH: \"$proj_dir\"
MODULE: work.ramen_timer
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: ramen_timer
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e ramen_timer -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edif2ngd\" -l LatticeXP2 -d LFXP2-5E \"ramen_timer.edi\" \"ramen_timer.ngo\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edfupdate\" -t \"ramen_timer.tcy\" -w \"ramen_timer.ngo\" -m \"ramen_timer.ngo\" \"ramen_timer.ngx\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/ngdbuild\" -a LatticeXP2 -d LFXP2-5E -p \"$fpga_dir/mg5a00/data\" \"ramen_timer.ngo\" \"ramen_timer.ngd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/map\" -a LatticeXP2 -p LFXP2-5E -t TQFP144 -s 6 \"ramen_timer.ngd\" -o \"ramen_timer_map.ncd\" -mp \"ramen_timer.mrp\" \"ramen_timer.lpf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.mt
-to ramen_timer.tw1
-o ramen_timer.tcm
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.mrp
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -m -f \"ramen_timer.cmm\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer_map.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.p2t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p2t: $rspFile"
} else {
	puts $rspFile "-w
-i 6
-l 5
-n 1
-t 1
-s 1
-c 0
-e 0
-exp parCDP=Auto
-exp parCDR=1
-exp parPlcInLimit=0
-exp parPlcInNeighborSize=1
-exp parPathBased=OFF
-exp parHold=OFF
"
	close $rspFile
}
if [catch {open ramen_timer.p3t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p3t: $rspFile"
} else {
	puts $rspFile "-rem
-log ramen_timer.log
-o ramen_timer_mp.par
-pr ramen_timer.prf
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/multipar\" -p ramen_timer.p2t -f \"ramen_timer.p3t\" \"ramen_timer_map.ncd\" \"ramen_timer.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.pt
-to ramen_timer.twr
-o ramen_timer.tcp
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.par
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -p -f \"ramen_timer.cmp\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer.ncd\" -l 60"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.t2b w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.t2b: $rspFile"
} else {
	puts $rspFile "-g DisableUES:FALSE
-g RamCfg:Reset
"
	close $rspFile
}
if [runCmd "\"$fpga_bin/bitgen\" -f \"ramen_timer.t2b\" -w \"ramen_timer.ncd\" -jedec -e -s \"ramen_timer.sec\" -k \"ramen_timer.bek\" \"ramen_timer.prf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/05/09 23:03:49 ###########


########## Tcl recorder starts at 06/05/09 23:08:18 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Generate Data File (JEDEC)
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open ramen_timer.cmd w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: ramen_timer
WORKING_PATH: \"$proj_dir\"
MODULE: work.ramen_timer
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: ramen_timer
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e ramen_timer -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edif2ngd\" -l LatticeXP2 -d LFXP2-5E \"ramen_timer.edi\" \"ramen_timer.ngo\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edfupdate\" -t \"ramen_timer.tcy\" -w \"ramen_timer.ngo\" -m \"ramen_timer.ngo\" \"ramen_timer.ngx\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/ngdbuild\" -a LatticeXP2 -d LFXP2-5E -p \"$fpga_dir/mg5a00/data\" \"ramen_timer.ngo\" \"ramen_timer.ngd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/map\" -a LatticeXP2 -p LFXP2-5E -t TQFP144 -s 6 \"ramen_timer.ngd\" -o \"ramen_timer_map.ncd\" -mp \"ramen_timer.mrp\" \"ramen_timer.lpf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.mt
-to ramen_timer.tw1
-o ramen_timer.tcm
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.mrp
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -m -f \"ramen_timer.cmm\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer_map.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.p2t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p2t: $rspFile"
} else {
	puts $rspFile "-w
-i 6
-l 5
-n 1
-t 1
-s 1
-c 0
-e 0
-exp parCDP=Auto
-exp parCDR=1
-exp parPlcInLimit=0
-exp parPlcInNeighborSize=1
-exp parPathBased=OFF
-exp parHold=OFF
"
	close $rspFile
}
if [catch {open ramen_timer.p3t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p3t: $rspFile"
} else {
	puts $rspFile "-rem
-log ramen_timer.log
-o ramen_timer_mp.par
-pr ramen_timer.prf
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/multipar\" -p ramen_timer.p2t -f \"ramen_timer.p3t\" \"ramen_timer_map.ncd\" \"ramen_timer.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.pt
-to ramen_timer.twr
-o ramen_timer.tcp
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.par
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -p -f \"ramen_timer.cmp\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer.ncd\" -l 60"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.t2b w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.t2b: $rspFile"
} else {
	puts $rspFile "-g DisableUES:FALSE
-g RamCfg:Reset
"
	close $rspFile
}
if [runCmd "\"$fpga_bin/bitgen\" -f \"ramen_timer.t2b\" -w \"ramen_timer.ncd\" -jedec -e -s \"ramen_timer.sec\" -k \"ramen_timer.bek\" \"ramen_timer.prf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/05/09 23:08:18 ###########


########## Tcl recorder starts at 06/05/09 23:14:42 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Place & Route Design
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open ramen_timer.cmd w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: ramen_timer
WORKING_PATH: \"$proj_dir\"
MODULE: work.ramen_timer
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: ramen_timer
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e ramen_timer -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edif2ngd\" -l LatticeXP2 -d LFXP2-5E \"ramen_timer.edi\" \"ramen_timer.ngo\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edfupdate\" -t \"ramen_timer.tcy\" -w \"ramen_timer.ngo\" -m \"ramen_timer.ngo\" \"ramen_timer.ngx\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/ngdbuild\" -a LatticeXP2 -d LFXP2-5E -p \"$fpga_dir/mg5a00/data\" \"ramen_timer.ngo\" \"ramen_timer.ngd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/map\" -a LatticeXP2 -p LFXP2-5E -t TQFP144 -s 6 \"ramen_timer.ngd\" -o \"ramen_timer_map.ncd\" -mp \"ramen_timer.mrp\" \"ramen_timer.lpf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.mt
-to ramen_timer.tw1
-o ramen_timer.tcm
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.mrp
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -m -f \"ramen_timer.cmm\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer_map.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.p2t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p2t: $rspFile"
} else {
	puts $rspFile "-w
-i 6
-l 5
-n 1
-t 1
-s 1
-c 0
-e 0
-exp parCDP=Auto
-exp parCDR=1
-exp parPlcInLimit=0
-exp parPlcInNeighborSize=1
-exp parPathBased=OFF
-exp parHold=OFF
"
	close $rspFile
}
if [catch {open ramen_timer.p3t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p3t: $rspFile"
} else {
	puts $rspFile "-rem
-log ramen_timer.log
-o ramen_timer_mp.par
-pr ramen_timer.prf
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/multipar\" -p ramen_timer.p2t -f \"ramen_timer.p3t\" \"ramen_timer_map.ncd\" \"ramen_timer.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/05/09 23:14:42 ###########


########## Tcl recorder starts at 06/05/09 23:15:16 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Generate Data File (JEDEC)
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open ramen_timer.cmd w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: ramen_timer
WORKING_PATH: \"$proj_dir\"
MODULE: work.ramen_timer
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: ramen_timer
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e ramen_timer -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edif2ngd\" -l LatticeXP2 -d LFXP2-5E \"ramen_timer.edi\" \"ramen_timer.ngo\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edfupdate\" -t \"ramen_timer.tcy\" -w \"ramen_timer.ngo\" -m \"ramen_timer.ngo\" \"ramen_timer.ngx\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/ngdbuild\" -a LatticeXP2 -d LFXP2-5E -p \"$fpga_dir/mg5a00/data\" \"ramen_timer.ngo\" \"ramen_timer.ngd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/map\" -a LatticeXP2 -p LFXP2-5E -t TQFP144 -s 6 \"ramen_timer.ngd\" -o \"ramen_timer_map.ncd\" -mp \"ramen_timer.mrp\" \"ramen_timer.lpf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.mt
-to ramen_timer.tw1
-o ramen_timer.tcm
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.mrp
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -m -f \"ramen_timer.cmm\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer_map.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.p2t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p2t: $rspFile"
} else {
	puts $rspFile "-w
-i 6
-l 5
-n 1
-t 1
-s 1
-c 0
-e 0
-exp parCDP=Auto
-exp parCDR=1
-exp parPlcInLimit=0
-exp parPlcInNeighborSize=1
-exp parPathBased=OFF
-exp parHold=OFF
"
	close $rspFile
}
if [catch {open ramen_timer.p3t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p3t: $rspFile"
} else {
	puts $rspFile "-rem
-log ramen_timer.log
-o ramen_timer_mp.par
-pr ramen_timer.prf
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/multipar\" -p ramen_timer.p2t -f \"ramen_timer.p3t\" \"ramen_timer_map.ncd\" \"ramen_timer.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.pt
-to ramen_timer.twr
-o ramen_timer.tcp
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.par
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -p -f \"ramen_timer.cmp\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer.ncd\" -l 60"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.t2b w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.t2b: $rspFile"
} else {
	puts $rspFile "-g DisableUES:FALSE
-g RamCfg:Reset
"
	close $rspFile
}
if [runCmd "\"$fpga_bin/bitgen\" -f \"ramen_timer.t2b\" -w \"ramen_timer.ncd\" -jedec -e -s \"ramen_timer.sec\" -k \"ramen_timer.bek\" \"ramen_timer.prf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/05/09 23:15:16 ###########


########## Tcl recorder starts at 06/05/09 23:17:40 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Synplify Synthesize VHDL File
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open SyncReset.cmd w} rspFile] {
	puts stderr "Cannot create response file SyncReset.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: SyncReset
WORKING_PATH: \"$proj_dir\"
MODULE: work.SyncReset
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: SyncReset
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e SyncReset -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/05/09 23:17:40 ###########


########## Tcl recorder starts at 06/05/09 23:18:08 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Synthesized EDIF File
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open SyncReset.cmd w} rspFile] {
	puts stderr "Cannot create response file SyncReset.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: SyncReset
WORKING_PATH: \"$proj_dir\"
MODULE: work.SyncReset
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: SyncReset
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e SyncReset -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/05/09 23:18:08 ###########


########## Tcl recorder starts at 06/05/09 23:21:22 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Synplify Synthesize VHDL File
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open SyncReset.cmd w} rspFile] {
	puts stderr "Cannot create response file SyncReset.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: SyncReset
WORKING_PATH: \"$proj_dir\"
MODULE: work.SyncReset
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: SyncReset
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e SyncReset -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/05/09 23:21:22 ###########


########## Tcl recorder starts at 06/05/09 23:21:37 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Synplify Synthesize VHDL File
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open ramen_timer.cmd w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: ramen_timer
WORKING_PATH: \"$proj_dir\"
MODULE: work.ramen_timer
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: ramen_timer
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e ramen_timer -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/05/09 23:21:37 ###########


########## Tcl recorder starts at 06/05/09 23:21:53 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Generate Data File (JEDEC)
if [runCmd "\"$fpga_bin/edif2ngd\" -l LatticeXP2 -d LFXP2-5E \"ramen_timer.edi\" \"ramen_timer.ngo\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edfupdate\" -t \"ramen_timer.tcy\" -w \"ramen_timer.ngo\" -m \"ramen_timer.ngo\" \"ramen_timer.ngx\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/ngdbuild\" -a LatticeXP2 -d LFXP2-5E -p \"$fpga_dir/mg5a00/data\" \"ramen_timer.ngo\" \"ramen_timer.ngd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/map\" -a LatticeXP2 -p LFXP2-5E -t TQFP144 -s 6 \"ramen_timer.ngd\" -o \"ramen_timer_map.ncd\" -mp \"ramen_timer.mrp\" \"ramen_timer.lpf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.mt
-to ramen_timer.tw1
-o ramen_timer.tcm
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.mrp
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -m -f \"ramen_timer.cmm\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer_map.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.p2t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p2t: $rspFile"
} else {
	puts $rspFile "-w
-i 6
-l 5
-n 1
-t 1
-s 1
-c 0
-e 0
-exp parCDP=Auto
-exp parCDR=1
-exp parPlcInLimit=0
-exp parPlcInNeighborSize=1
-exp parPathBased=OFF
-exp parHold=OFF
"
	close $rspFile
}
if [catch {open ramen_timer.p3t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p3t: $rspFile"
} else {
	puts $rspFile "-rem
-log ramen_timer.log
-o ramen_timer_mp.par
-pr ramen_timer.prf
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/multipar\" -p ramen_timer.p2t -f \"ramen_timer.p3t\" \"ramen_timer_map.ncd\" \"ramen_timer.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.pt
-to ramen_timer.twr
-o ramen_timer.tcp
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.par
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -p -f \"ramen_timer.cmp\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer.ncd\" -l 60"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.t2b w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.t2b: $rspFile"
} else {
	puts $rspFile "-g DisableUES:FALSE
-g RamCfg:Reset
"
	close $rspFile
}
if [runCmd "\"$fpga_bin/bitgen\" -f \"ramen_timer.t2b\" -w \"ramen_timer.ncd\" -jedec -e -s \"ramen_timer.sec\" -k \"ramen_timer.bek\" \"ramen_timer.prf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/05/09 23:21:53 ###########


########## Tcl recorder starts at 06/05/09 23:42:37 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Synplify Synthesize VHDL File
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open ramen_timer.cmd w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: ramen_timer
WORKING_PATH: \"$proj_dir\"
MODULE: work.ramen_timer
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: ramen_timer
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e ramen_timer -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/05/09 23:42:37 ###########


########## Tcl recorder starts at 06/05/09 23:42:56 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Build Database
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open ramen_timer.cmd w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: ramen_timer
WORKING_PATH: \"$proj_dir\"
MODULE: work.ramen_timer
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: ramen_timer
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e ramen_timer -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edif2ngd\" -l LatticeXP2 -d LFXP2-5E \"ramen_timer.edi\" \"ramen_timer.ngo\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edfupdate\" -t \"ramen_timer.tcy\" -w \"ramen_timer.ngo\" -m \"ramen_timer.ngo\" \"ramen_timer.ngx\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/ngdbuild\" -a LatticeXP2 -d LFXP2-5E -p \"$fpga_dir/mg5a00/data\" \"ramen_timer.ngo\" \"ramen_timer.ngd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/05/09 23:42:56 ###########


########## Tcl recorder starts at 06/05/09 23:43:35 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Build Database
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open ramen_timer.cmd w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: ramen_timer
WORKING_PATH: \"$proj_dir\"
MODULE: work.ramen_timer
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: ramen_timer
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e ramen_timer -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edif2ngd\" -l LatticeXP2 -d LFXP2-5E \"ramen_timer.edi\" \"ramen_timer.ngo\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edfupdate\" -t \"ramen_timer.tcy\" -w \"ramen_timer.ngo\" -m \"ramen_timer.ngo\" \"ramen_timer.ngx\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/ngdbuild\" -a LatticeXP2 -d LFXP2-5E -p \"$fpga_dir/mg5a00/data\" \"ramen_timer.ngo\" \"ramen_timer.ngd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/05/09 23:43:35 ###########


########## Tcl recorder starts at 06/05/09 23:45:13 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Build Database
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open ramen_timer.cmd w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: ramen_timer
WORKING_PATH: \"$proj_dir\"
MODULE: work.ramen_timer
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: ramen_timer
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e ramen_timer -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edif2ngd\" -l LatticeXP2 -d LFXP2-5E \"ramen_timer.edi\" \"ramen_timer.ngo\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edfupdate\" -t \"ramen_timer.tcy\" -w \"ramen_timer.ngo\" -m \"ramen_timer.ngo\" \"ramen_timer.ngx\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/ngdbuild\" -a LatticeXP2 -d LFXP2-5E -p \"$fpga_dir/mg5a00/data\" \"ramen_timer.ngo\" \"ramen_timer.ngd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/05/09 23:45:13 ###########


########## Tcl recorder starts at 06/05/09 23:45:28 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Build Database
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open ramen_timer.cmd w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: ramen_timer
WORKING_PATH: \"$proj_dir\"
MODULE: work.ramen_timer
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: ramen_timer
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e ramen_timer -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edif2ngd\" -l LatticeXP2 -d LFXP2-5E \"ramen_timer.edi\" \"ramen_timer.ngo\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edfupdate\" -t \"ramen_timer.tcy\" -w \"ramen_timer.ngo\" -m \"ramen_timer.ngo\" \"ramen_timer.ngx\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/ngdbuild\" -a LatticeXP2 -d LFXP2-5E -p \"$fpga_dir/mg5a00/data\" \"ramen_timer.ngo\" \"ramen_timer.ngd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/05/09 23:45:28 ###########


########## Tcl recorder starts at 06/05/09 23:48:01 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Build Database
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open ramen_timer.cmd w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: ramen_timer
WORKING_PATH: \"$proj_dir\"
MODULE: work.ramen_timer
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: ramen_timer
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e ramen_timer -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edif2ngd\" -l LatticeXP2 -d LFXP2-5E \"ramen_timer.edi\" \"ramen_timer.ngo\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edfupdate\" -t \"ramen_timer.tcy\" -w \"ramen_timer.ngo\" -m \"ramen_timer.ngo\" \"ramen_timer.ngx\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/ngdbuild\" -a LatticeXP2 -d LFXP2-5E -p \"$fpga_dir/mg5a00/data\" \"ramen_timer.ngo\" \"ramen_timer.ngd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/05/09 23:48:01 ###########


########## Tcl recorder starts at 06/05/09 23:49:10 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Build Database
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open ramen_timer.cmd w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: ramen_timer
WORKING_PATH: \"$proj_dir\"
MODULE: work.ramen_timer
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: ramen_timer
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e ramen_timer -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edif2ngd\" -l LatticeXP2 -d LFXP2-5E \"ramen_timer.edi\" \"ramen_timer.ngo\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edfupdate\" -t \"ramen_timer.tcy\" -w \"ramen_timer.ngo\" -m \"ramen_timer.ngo\" \"ramen_timer.ngx\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/ngdbuild\" -a LatticeXP2 -d LFXP2-5E -p \"$fpga_dir/mg5a00/data\" \"ramen_timer.ngo\" \"ramen_timer.ngd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/05/09 23:49:10 ###########


########## Tcl recorder starts at 06/05/09 23:49:35 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Generate Data File (JEDEC)
if [runCmd "\"$fpga_bin/map\" -a LatticeXP2 -p LFXP2-5E -t TQFP144 -s 6 \"ramen_timer.ngd\" -o \"ramen_timer_map.ncd\" -mp \"ramen_timer.mrp\" \"ramen_timer.lpf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.mt
-to ramen_timer.tw1
-o ramen_timer.tcm
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.mrp
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -m -f \"ramen_timer.cmm\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer_map.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.p2t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p2t: $rspFile"
} else {
	puts $rspFile "-w
-i 6
-l 5
-n 1
-t 1
-s 1
-c 0
-e 0
-exp parCDP=Auto
-exp parCDR=1
-exp parPlcInLimit=0
-exp parPlcInNeighborSize=1
-exp parPathBased=OFF
-exp parHold=OFF
"
	close $rspFile
}
if [catch {open ramen_timer.p3t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p3t: $rspFile"
} else {
	puts $rspFile "-rem
-log ramen_timer.log
-o ramen_timer_mp.par
-pr ramen_timer.prf
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/multipar\" -p ramen_timer.p2t -f \"ramen_timer.p3t\" \"ramen_timer_map.ncd\" \"ramen_timer.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.pt
-to ramen_timer.twr
-o ramen_timer.tcp
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.par
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -p -f \"ramen_timer.cmp\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer.ncd\" -l 60"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.t2b w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.t2b: $rspFile"
} else {
	puts $rspFile "-g DisableUES:FALSE
-g RamCfg:Reset
"
	close $rspFile
}
if [runCmd "\"$fpga_bin/bitgen\" -f \"ramen_timer.t2b\" -w \"ramen_timer.ncd\" -jedec -e -s \"ramen_timer.sec\" -k \"ramen_timer.bek\" \"ramen_timer.prf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/05/09 23:49:35 ###########


########## Tcl recorder starts at 06/06/09 00:00:44 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Synplify Synthesize VHDL File
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open alerm.cmd w} rspFile] {
	puts stderr "Cannot create response file alerm.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: alerm
WORKING_PATH: \"$proj_dir\"
MODULE: work.alerm
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: alerm
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e alerm -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/06/09 00:00:44 ###########


########## Tcl recorder starts at 06/06/09 00:02:26 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Synplify Synthesize VHDL File
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open alerm.cmd w} rspFile] {
	puts stderr "Cannot create response file alerm.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: alerm
WORKING_PATH: \"$proj_dir\"
MODULE: work.alerm
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: alerm
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e alerm -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/06/09 00:02:26 ###########


########## Tcl recorder starts at 06/06/09 00:02:43 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Generate Data File (JEDEC)
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open ramen_timer.cmd w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: ramen_timer
WORKING_PATH: \"$proj_dir\"
MODULE: work.ramen_timer
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: ramen_timer
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e ramen_timer -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edif2ngd\" -l LatticeXP2 -d LFXP2-5E \"ramen_timer.edi\" \"ramen_timer.ngo\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edfupdate\" -t \"ramen_timer.tcy\" -w \"ramen_timer.ngo\" -m \"ramen_timer.ngo\" \"ramen_timer.ngx\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/ngdbuild\" -a LatticeXP2 -d LFXP2-5E -p \"$fpga_dir/mg5a00/data\" \"ramen_timer.ngo\" \"ramen_timer.ngd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/map\" -a LatticeXP2 -p LFXP2-5E -t TQFP144 -s 6 \"ramen_timer.ngd\" -o \"ramen_timer_map.ncd\" -mp \"ramen_timer.mrp\" \"ramen_timer.lpf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.mt
-to ramen_timer.tw1
-o ramen_timer.tcm
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.mrp
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -m -f \"ramen_timer.cmm\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer_map.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.p2t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p2t: $rspFile"
} else {
	puts $rspFile "-w
-i 6
-l 5
-n 1
-t 1
-s 1
-c 0
-e 0
-exp parCDP=Auto
-exp parCDR=1
-exp parPlcInLimit=0
-exp parPlcInNeighborSize=1
-exp parPathBased=OFF
-exp parHold=OFF
"
	close $rspFile
}
if [catch {open ramen_timer.p3t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p3t: $rspFile"
} else {
	puts $rspFile "-rem
-log ramen_timer.log
-o ramen_timer_mp.par
-pr ramen_timer.prf
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/multipar\" -p ramen_timer.p2t -f \"ramen_timer.p3t\" \"ramen_timer_map.ncd\" \"ramen_timer.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.pt
-to ramen_timer.twr
-o ramen_timer.tcp
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.par
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -p -f \"ramen_timer.cmp\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer.ncd\" -l 60"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.t2b w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.t2b: $rspFile"
} else {
	puts $rspFile "-g DisableUES:FALSE
-g RamCfg:Reset
"
	close $rspFile
}
if [runCmd "\"$fpga_bin/bitgen\" -f \"ramen_timer.t2b\" -w \"ramen_timer.ncd\" -jedec -e -s \"ramen_timer.sec\" -k \"ramen_timer.bek\" \"ramen_timer.prf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/06/09 00:02:43 ###########


########## Tcl recorder starts at 06/06/09 00:09:28 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Generate Data File (JEDEC)
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open ramen_timer.cmd w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: ramen_timer
WORKING_PATH: \"$proj_dir\"
MODULE: work.ramen_timer
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: ramen_timer
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e ramen_timer -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edif2ngd\" -l LatticeXP2 -d LFXP2-5E \"ramen_timer.edi\" \"ramen_timer.ngo\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edfupdate\" -t \"ramen_timer.tcy\" -w \"ramen_timer.ngo\" -m \"ramen_timer.ngo\" \"ramen_timer.ngx\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/ngdbuild\" -a LatticeXP2 -d LFXP2-5E -p \"$fpga_dir/mg5a00/data\" \"ramen_timer.ngo\" \"ramen_timer.ngd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/map\" -a LatticeXP2 -p LFXP2-5E -t TQFP144 -s 6 \"ramen_timer.ngd\" -o \"ramen_timer_map.ncd\" -mp \"ramen_timer.mrp\" \"ramen_timer.lpf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.mt
-to ramen_timer.tw1
-o ramen_timer.tcm
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.mrp
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -m -f \"ramen_timer.cmm\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer_map.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.p2t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p2t: $rspFile"
} else {
	puts $rspFile "-w
-i 6
-l 5
-n 1
-t 1
-s 1
-c 0
-e 0
-exp parCDP=Auto
-exp parCDR=1
-exp parPlcInLimit=0
-exp parPlcInNeighborSize=1
-exp parPathBased=OFF
-exp parHold=OFF
"
	close $rspFile
}
if [catch {open ramen_timer.p3t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p3t: $rspFile"
} else {
	puts $rspFile "-rem
-log ramen_timer.log
-o ramen_timer_mp.par
-pr ramen_timer.prf
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/multipar\" -p ramen_timer.p2t -f \"ramen_timer.p3t\" \"ramen_timer_map.ncd\" \"ramen_timer.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.pt
-to ramen_timer.twr
-o ramen_timer.tcp
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.par
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -p -f \"ramen_timer.cmp\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer.ncd\" -l 60"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.t2b w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.t2b: $rspFile"
} else {
	puts $rspFile "-g DisableUES:FALSE
-g RamCfg:Reset
"
	close $rspFile
}
if [runCmd "\"$fpga_bin/bitgen\" -f \"ramen_timer.t2b\" -w \"ramen_timer.ncd\" -jedec -e -s \"ramen_timer.sec\" -k \"ramen_timer.bek\" \"ramen_timer.prf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/06/09 00:09:28 ###########


########## Tcl recorder starts at 06/06/09 00:22:15 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Synplify Synthesize VHDL File
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open alerm.cmd w} rspFile] {
	puts stderr "Cannot create response file alerm.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: alerm
WORKING_PATH: \"$proj_dir\"
MODULE: work.alerm
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: alerm
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e alerm -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/06/09 00:22:15 ###########


########## Tcl recorder starts at 06/06/09 00:22:54 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Synplify Synthesize VHDL File
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open alerm.cmd w} rspFile] {
	puts stderr "Cannot create response file alerm.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: alerm
WORKING_PATH: \"$proj_dir\"
MODULE: work.alerm
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: alerm
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e alerm -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/06/09 00:22:54 ###########


########## Tcl recorder starts at 06/06/09 00:23:19 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Synplify Synthesize VHDL File
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open alerm.cmd w} rspFile] {
	puts stderr "Cannot create response file alerm.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: alerm
WORKING_PATH: \"$proj_dir\"
MODULE: work.alerm
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: alerm
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e alerm -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/06/09 00:23:19 ###########


########## Tcl recorder starts at 06/06/09 00:24:50 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Synplify Synthesize VHDL File
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open alerm.cmd w} rspFile] {
	puts stderr "Cannot create response file alerm.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: alerm
WORKING_PATH: \"$proj_dir\"
MODULE: work.alerm
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: alerm
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e alerm -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/06/09 00:24:50 ###########


########## Tcl recorder starts at 06/06/09 00:25:07 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Generate Data File (JEDEC)
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open ramen_timer.cmd w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: ramen_timer
WORKING_PATH: \"$proj_dir\"
MODULE: work.ramen_timer
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: ramen_timer
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e ramen_timer -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edif2ngd\" -l LatticeXP2 -d LFXP2-5E \"ramen_timer.edi\" \"ramen_timer.ngo\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edfupdate\" -t \"ramen_timer.tcy\" -w \"ramen_timer.ngo\" -m \"ramen_timer.ngo\" \"ramen_timer.ngx\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/ngdbuild\" -a LatticeXP2 -d LFXP2-5E -p \"$fpga_dir/mg5a00/data\" \"ramen_timer.ngo\" \"ramen_timer.ngd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/map\" -a LatticeXP2 -p LFXP2-5E -t TQFP144 -s 6 \"ramen_timer.ngd\" -o \"ramen_timer_map.ncd\" -mp \"ramen_timer.mrp\" \"ramen_timer.lpf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.mt
-to ramen_timer.tw1
-o ramen_timer.tcm
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.mrp
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -m -f \"ramen_timer.cmm\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer_map.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.p2t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p2t: $rspFile"
} else {
	puts $rspFile "-w
-i 6
-l 5
-n 1
-t 1
-s 1
-c 0
-e 0
-exp parCDP=Auto
-exp parCDR=1
-exp parPlcInLimit=0
-exp parPlcInNeighborSize=1
-exp parPathBased=OFF
-exp parHold=OFF
"
	close $rspFile
}
if [catch {open ramen_timer.p3t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p3t: $rspFile"
} else {
	puts $rspFile "-rem
-log ramen_timer.log
-o ramen_timer_mp.par
-pr ramen_timer.prf
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/multipar\" -p ramen_timer.p2t -f \"ramen_timer.p3t\" \"ramen_timer_map.ncd\" \"ramen_timer.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.pt
-to ramen_timer.twr
-o ramen_timer.tcp
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.par
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -p -f \"ramen_timer.cmp\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer.ncd\" -l 60"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.t2b w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.t2b: $rspFile"
} else {
	puts $rspFile "-g DisableUES:FALSE
-g RamCfg:Reset
"
	close $rspFile
}
if [runCmd "\"$fpga_bin/bitgen\" -f \"ramen_timer.t2b\" -w \"ramen_timer.ncd\" -jedec -e -s \"ramen_timer.sec\" -k \"ramen_timer.bek\" \"ramen_timer.prf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/06/09 00:25:07 ###########


########## Tcl recorder starts at 06/06/09 00:28:32 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Generate Data File (JEDEC)
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open ramen_timer.cmd w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: ramen_timer
WORKING_PATH: \"$proj_dir\"
MODULE: work.ramen_timer
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: ramen_timer
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e ramen_timer -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edif2ngd\" -l LatticeXP2 -d LFXP2-5E \"ramen_timer.edi\" \"ramen_timer.ngo\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edfupdate\" -t \"ramen_timer.tcy\" -w \"ramen_timer.ngo\" -m \"ramen_timer.ngo\" \"ramen_timer.ngx\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/ngdbuild\" -a LatticeXP2 -d LFXP2-5E -p \"$fpga_dir/mg5a00/data\" \"ramen_timer.ngo\" \"ramen_timer.ngd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/map\" -a LatticeXP2 -p LFXP2-5E -t TQFP144 -s 6 \"ramen_timer.ngd\" -o \"ramen_timer_map.ncd\" -mp \"ramen_timer.mrp\" \"ramen_timer.lpf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.mt
-to ramen_timer.tw1
-o ramen_timer.tcm
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.mrp
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -m -f \"ramen_timer.cmm\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer_map.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.p2t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p2t: $rspFile"
} else {
	puts $rspFile "-w
-i 6
-l 5
-n 1
-t 1
-s 1
-c 0
-e 0
-exp parCDP=Auto
-exp parCDR=1
-exp parPlcInLimit=0
-exp parPlcInNeighborSize=1
-exp parPathBased=OFF
-exp parHold=OFF
"
	close $rspFile
}
if [catch {open ramen_timer.p3t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p3t: $rspFile"
} else {
	puts $rspFile "-rem
-log ramen_timer.log
-o ramen_timer_mp.par
-pr ramen_timer.prf
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/multipar\" -p ramen_timer.p2t -f \"ramen_timer.p3t\" \"ramen_timer_map.ncd\" \"ramen_timer.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.pt
-to ramen_timer.twr
-o ramen_timer.tcp
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.par
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -p -f \"ramen_timer.cmp\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer.ncd\" -l 60"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.t2b w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.t2b: $rspFile"
} else {
	puts $rspFile "-g DisableUES:FALSE
-g RamCfg:Reset
"
	close $rspFile
}
if [runCmd "\"$fpga_bin/bitgen\" -f \"ramen_timer.t2b\" -w \"ramen_timer.ncd\" -jedec -e -s \"ramen_timer.sec\" -k \"ramen_timer.bek\" \"ramen_timer.prf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/06/09 00:28:32 ###########


########## Tcl recorder starts at 06/06/09 00:37:32 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Generate Data File (JEDEC)
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open ramen_timer.cmd w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: ramen_timer
WORKING_PATH: \"$proj_dir\"
MODULE: work.ramen_timer
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: ramen_timer
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e ramen_timer -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edif2ngd\" -l LatticeXP2 -d LFXP2-5E \"ramen_timer.edi\" \"ramen_timer.ngo\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edfupdate\" -t \"ramen_timer.tcy\" -w \"ramen_timer.ngo\" -m \"ramen_timer.ngo\" \"ramen_timer.ngx\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/ngdbuild\" -a LatticeXP2 -d LFXP2-5E -p \"$fpga_dir/mg5a00/data\" \"ramen_timer.ngo\" \"ramen_timer.ngd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/map\" -a LatticeXP2 -p LFXP2-5E -t TQFP144 -s 6 \"ramen_timer.ngd\" -o \"ramen_timer_map.ncd\" -mp \"ramen_timer.mrp\" \"ramen_timer.lpf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.mt
-to ramen_timer.tw1
-o ramen_timer.tcm
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.mrp
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -m -f \"ramen_timer.cmm\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer_map.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.p2t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p2t: $rspFile"
} else {
	puts $rspFile "-w
-i 6
-l 5
-n 1
-t 1
-s 1
-c 0
-e 0
-exp parCDP=Auto
-exp parCDR=1
-exp parPlcInLimit=0
-exp parPlcInNeighborSize=1
-exp parPathBased=OFF
-exp parHold=OFF
"
	close $rspFile
}
if [catch {open ramen_timer.p3t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p3t: $rspFile"
} else {
	puts $rspFile "-rem
-log ramen_timer.log
-o ramen_timer_mp.par
-pr ramen_timer.prf
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/multipar\" -p ramen_timer.p2t -f \"ramen_timer.p3t\" \"ramen_timer_map.ncd\" \"ramen_timer.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.pt
-to ramen_timer.twr
-o ramen_timer.tcp
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.par
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -p -f \"ramen_timer.cmp\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer.ncd\" -l 60"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.t2b w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.t2b: $rspFile"
} else {
	puts $rspFile "-g DisableUES:FALSE
-g RamCfg:Reset
"
	close $rspFile
}
if [runCmd "\"$fpga_bin/bitgen\" -f \"ramen_timer.t2b\" -w \"ramen_timer.ncd\" -jedec -e -s \"ramen_timer.sec\" -k \"ramen_timer.bek\" \"ramen_timer.prf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/06/09 00:37:32 ###########


########## Tcl recorder starts at 06/06/09 00:43:20 ##########

set version "7.2"
set proj_dir "C:/Documents and Settings/rerofumi/My Documents/pld_develop/ramen_timer_lattice"
cd $proj_dir

# Get directory paths
set pver $version
regsub -all {\.} $pver {_} pver
set lscfile "lsc_"
append lscfile $pver ".ini"
set lsvini_dir [lindex [array get env LSC_INI_PATH] 1]
set lsvini_path [file join $lsvini_dir $lscfile]
if {[catch {set fid [open $lsvini_path]} msg]} {
	 puts "File Open Error: $lsvini_path"
	 return false
} else {set data [read $fid]; close $fid }
foreach line [split $data '\n'] { 
	set lline [string tolower $line]
	set lline [string trim $lline]
	if {[string compare $lline "\[paths\]"] == 0} { set path 1; continue}
	if {$path && [regexp {^\[} $lline]} {set path 0; break}
	if {$path && [regexp {^bin} $lline]} {set cpld_bin $line; continue}
	if {$path && [regexp {^fpgapath} $lline]} {set fpga_dir $line; continue}
	if {$path && [regexp {^fpgabinpath} $lline]} {set fpga_bin $line}}

set cpld_bin [string range $cpld_bin [expr [string first "=" $cpld_bin]+1] end]
regsub -all "\"" $cpld_bin "" cpld_bin
set cpld_bin [file join $cpld_bin]
set install_dir [string range $cpld_bin 0 [expr [string first "ispcpld" $cpld_bin]-2]]
regsub -all "\"" $install_dir "" install_dir
set install_dir [file join $install_dir]
set fpga_dir [string range $fpga_dir [expr [string first "=" $fpga_dir]+1] end]
regsub -all "\"" $fpga_dir "" fpga_dir
set fpga_dir [file join $fpga_dir]
set fpga_bin [string range $fpga_bin [expr [string first "=" $fpga_bin]+1] end]
regsub -all "\"" $fpga_bin "" fpga_bin
set fpga_bin [file join $fpga_bin]

if {[string match "*$fpga_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$fpga_bin;$env(PATH)" }

if {[string match "*$cpld_bin;*" $env(PATH)] == 0 } {
   set env(PATH) "$cpld_bin;$env(PATH)" }

lappend auto_path [file join $install_dir "ispcpld" "tcltk" "lib" "ispwidget" "runproc"]
package require runcmd

# Commands to make the Process: 
# Generate Data File (JEDEC)
if [catch {open ramen_timer.rvp w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.rvp: $rspFile"
} else {
	puts $rspFile "STYFILENAME=ramen_timer.sty
PROJECT=ramen_timer
ENTRY=Pure VHDL
WORKING_PATH=$proj_dir
MODULE=ramen_timer
TOP_FILE=ramen_timer.vhd
EDF_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VHDL_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
VERILOG_FILE_LIST=beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
DEVICEPART=LFXP2-5E-6TN144C
"
	close $rspFile
}
if [catch {open ramen_timer.cmd w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cmd: $rspFile"
} else {
	puts $rspFile "STYFILENAME: ramen_timer.sty
PROJECT: ramen_timer
WORKING_PATH: \"$proj_dir\"
MODULE: work.ramen_timer
VHDL_FILE_LIST: \"$install_dir/ispcpld/../cae_library/synthesis/vhdl/XP2.vhd\" beep_alarm.vhd sync_reset.vhd 7seg_drv.vhd counter10.vhd ramen_timer.vhd
OUTPUT_FILE_NAME: ramen_timer
SUFFIX_NAME: edi
WRITE_PRF: false
FREQUENCY:  200
FANOUT_LIMIT:  100
DISABLE_IO_INSERTION: false
FORCE_GSR: false
SPEED_GRADE: -6
SYMBOLIC_FSM_COMPILER: true
NUM_CRITICAL_PATHS:   3
AUTO_CONSTRAIN_IO: true
NUM_STARTEND_POINTS:   0
COMPILER_COMPATIBLE: true
RETIMING: none
RESOURCE_SHARING: true
DEFAULT_ENUM_ENCODING: default
fixgatedclocks:  3
fixgeneratedclocks:  3
Vlog_std_v2001: V2001
DUP: false
ARRANGE_VHDL_FILES: true
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/Synpwrap\" -dyn -e ramen_timer -target LATTICE-XP2 -part LFXP2_5E -notPro -oem"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edif2ngd\" -l LatticeXP2 -d LFXP2-5E \"ramen_timer.edi\" \"ramen_timer.ngo\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/edfupdate\" -t \"ramen_timer.tcy\" -w \"ramen_timer.ngo\" -m \"ramen_timer.ngo\" \"ramen_timer.ngx\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/ngdbuild\" -a LatticeXP2 -d LFXP2-5E -p \"$fpga_dir/mg5a00/data\" \"ramen_timer.ngo\" \"ramen_timer.ngd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [runCmd "\"$fpga_bin/map\" -a LatticeXP2 -p LFXP2-5E -t TQFP144 -s 6 \"ramen_timer.ngd\" -o \"ramen_timer_map.ncd\" -mp \"ramen_timer.mrp\" \"ramen_timer.lpf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.mt
-to ramen_timer.tw1
-o ramen_timer.tcm
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.mrp
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -m -f \"ramen_timer.cmm\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer_map.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.p2t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p2t: $rspFile"
} else {
	puts $rspFile "-w
-i 6
-l 5
-n 1
-t 1
-s 1
-c 0
-e 0
-exp parCDP=Auto
-exp parCDR=1
-exp parPlcInLimit=0
-exp parPlcInNeighborSize=1
-exp parPathBased=OFF
-exp parHold=OFF
"
	close $rspFile
}
if [catch {open ramen_timer.p3t w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.p3t: $rspFile"
} else {
	puts $rspFile "-rem
-log ramen_timer.log
-o ramen_timer_mp.par
-pr ramen_timer.prf
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/multipar\" -p ramen_timer.p2t -f \"ramen_timer.p3t\" \"ramen_timer_map.ncd\" \"ramen_timer.ncd\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
if [catch {open ramen_timer.cm2 w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.cm2: $rspFile"
} else {
	puts $rspFile "-t ramen_timer.pt
-to ramen_timer.twr
-o ramen_timer.tcp
-log ramen_timer.log
-pr ramen_timer.prf
-rpt ramen_timer.par
"
	close $rspFile
}
if [runCmd "\"$cpld_bin/checkpoint\" -p -f \"ramen_timer.cmp\" -f \"ramen_timer.cm2\" -arch LatticeXP2 \"ramen_timer.ncd\" -l 60"] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}
file delete ramen_timer.cm2
if [catch {open ramen_timer.t2b w} rspFile] {
	puts stderr "Cannot create response file ramen_timer.t2b: $rspFile"
} else {
	puts $rspFile "-g DisableUES:FALSE
-g RamCfg:Reset
"
	close $rspFile
}
if [runCmd "\"$fpga_bin/bitgen\" -f \"ramen_timer.t2b\" -w \"ramen_timer.ncd\" -jedec -e -s \"ramen_timer.sec\" -k \"ramen_timer.bek\" \"ramen_timer.prf\""] {
	return
} else {
	vwait done
	if [checkResult $done] {
		return
	}
}

########## Tcl recorder end at 06/06/09 00:43:20 ###########

